// libary 
  #include <WiFi.h>
  #include <AsyncTCP.h>
  #include <ESPAsyncWebServer.h>
  #include <AsyncElegantOTA.h>
  #include <PubSubClient.h>
  #include <SPI.h>
  #include <RFID.h>
  #include <Wire.h> 
  #include <LiquidCrystal_I2C.h>
  #include "time.h"
  #include "sntp.h"

// LCD & time
  LiquidCrystal_I2C lcd(0x27,20,4);
  const char* ntpServer = "pool.ntp.org";
  const long  gmtOffset_sec = 0;
  const int   daylightOffset_sec = 3600;
  const char* time_zone = "GMT0";
  struct tm timeinfo;

// wifi
  const char* ssid = "............................";
  const char* password = "......................";
  AsyncWebServer server(80);

//mqtt & RFID
  RFID monModuleRFID(5,18);

  #define piezzo 14
  
  #define led1 13
  #define led2 15
  #define led3 2
  #define led4 4
 
  WiFiClient espClient;
  PubSubClient client(espClient);
  const char* mqtt_server = "....................";




// variable
  int etat_module = 0;
  int etat_access = 0;
  int counter = 0;
  int buttonvalue = 0;
  int prevbuttonvalue = 0;
  
  unsigned long myTime;
  unsigned long prev_time_rfid ;
  const long interval_rfid = 3000;
  unsigned long prev_time_rfid_1 ;
  const long interval_rfid_1 = 3000;
  
  int UID[5];
  #define MSG_BUFFER_SIZE  (50)
  char msg1[MSG_BUFFER_SIZE];
  String code_rfid ="";
  String last_code_rfid ="";
  String ID_machine ="";

  int compteur = 0 ;
  bool etatA ;
  bool dernierEtatA ;
  long unsigned tempsA ;


  String Machine[5][2]= {
    {"001","   >Epilog_Laser<   "},
    {"002","       >Prusa<      "},
    {"003","      >Shopbot<     "},
    {"004","      >monofab<     "},
    {"005","      >Shaper<      "},
  };
  

// rotary 
  #define pinA 25 
  #define pinB 32
  #define pinButton 33

// void LCD

  void setup_LCD2004() {
    lcd.init();
    lcd.backlight();
    configTzTime(time_zone, ntpServer);
        
  }

  void starting(){

    lcd.setCursor(6,1);
    lcd.print("NUM_PASS");
    lcd.setCursor(5,2);
    lcd.print("Y'ELLO LAB");
    
    }

  void erreur_wifi(){

    lcd.setCursor(0,1);
    lcd.print("      NUM_PASS      ");
    lcd.setCursor(0,2);
    lcd.print("    erreur  Wifi    ");
    
    }

  void erreur_server(){

    lcd.setCursor(0,1);
    lcd.print("      NUM_PASS      ");
    lcd.setCursor(0,2);
    lcd.print("   erreur serveur   ");
    
    }

  void acces_denied(){

    lcd.setCursor(0,1);
    lcd.print("   access denied    ");
    lcd.setCursor(0,2);
    lcd.print("     Invalid ID     ");
    
    }

  void acces(){

    lcd.setCursor(0,1);
    lcd.print("   Select Machine   ");
    lcd.setCursor(0,2);
    lcd.print(Machine[compteur][1]);
    
  }

  void acces_1(){

      lcd.setCursor(0,1);
      lcd.print("   Machine status  ");

      if(compteur == 1){
      lcd.setCursor(0,2);
      lcd.print("      >ON   OFF    ");
      }
      
      if(compteur == 0){
      lcd.setCursor(0,2);
      lcd.print("      ON   >OFF    ");
      }
    
  }
    
    
  void home_display()
  {
    if(!getLocalTime(&timeinfo)){
      Serial.println("Failed to obtain time");
      return;
    }
  
    lcd.setCursor(0,0);
    lcd.print(&timeinfo,"%d/%m/%y");
    lcd.setCursor(12,0);
    lcd.print(&timeinfo,"%H:%M:%S");
    lcd.setCursor(0,3);
    lcd.print("NUMPASS          Run");
    
  }

  void ID_display (){

    lcd.setCursor(0,1);
    lcd.print("      Sign  in      ");
    lcd.setCursor(0,2);
    lcd.print("Please Scan  your ID");
    digitalWrite(led1, LOW);
    digitalWrite(led2, HIGH);
    digitalWrite(led3, LOW);
    digitalWrite(led4, HIGH);
    
  }

  void menu_display (){

    lcd.setCursor(0,1);
    lcd.print("   Select Machine   ");
    lcd.setCursor(0,2);
    lcd.print("Epilog Laser");
    
  
  }

//void OTA

  void setup_OTA () {
    Serial.begin(115200);
    WiFi.mode(WIFI_STA);
    WiFi.begin(ssid, password);
    Serial.println("");

    // Wait for connection
    while (WiFi.status() != WL_CONNECTED) {
      erreur_wifi();
      delay(500);
      Serial.print(".");
    }
    
    Serial.println("");
    Serial.print("Connected to ");
    Serial.println(ssid);
    Serial.print("IP address: ");
    Serial.println(WiFi.localIP());

    server.on("/", HTTP_GET, [](AsyncWebServerRequest *request) {
      request->send(200, "text/plain", "Hi! I am ESP32 of y'ello lab .");
    });


    AsyncElegantOTA.begin(&server, "YELLOLab", "Yellolab@Inphb1234");    // Start ElegantOTA
    server.begin();
    Serial.println("HTTP server started");
  
  }


//void MQTT
  void callback(char* topic, byte* payload, unsigned int length) {
    Serial.println((char)payload[0]);
    if ((char)payload[0] == '1') {

      etat_module = 1;
      
      digitalWrite(piezzo, LOW);
      digitalWrite(led1, HIGH);
      digitalWrite(led2, LOW);
      digitalWrite(led3, HIGH);
      digitalWrite(led4, LOW);
    
      } 
    
    if ((char)payload[0] == '0') {
      etat_module = 0;
      acces_denied();
      digitalWrite(piezzo, HIGH);
      delay(5000);
      digitalWrite(piezzo, LOW);
      
      }
    }


  void reconnect() {
    // Loop until we're reconnected
    while (!client.connected()) {
      
      // Create a random client ID
      String clientId = "ESP35Client-";
      clientId += String(random(0xffff), HEX);
      // Attempt to connect
      if (client.connect("NUMPASS501")) {
        //Serial.println("connected");
        client.subscribe("NUMPASS1");
      } else {
        erreur_server();
        delay(5000);
      }
    }
  }


  void setup_mqtt() {

    
    pinMode(piezzo,OUTPUT);
    pinMode(led1,OUTPUT);
    pinMode(led2,OUTPUT);
    pinMode(led3,OUTPUT);
    pinMode(led4,OUTPUT);
    client.setServer(mqtt_server, 1883);
    client.setCallback(callback);
  
    SPI.begin();
  
    monModuleRFID.init();
    
    
    }


// void rfid
  void rfid() {
    if (monModuleRFID.isCard()) {  
      if (monModuleRFID.readCardSerial()) {        
         for(int i=0;i<=4;i++)
         {
            UID[i]=monModuleRFID.serNum[i];  
         }
            
      }
            
      code_rfid = UID[0];
      code_rfid += UID[1];
      code_rfid += UID[2];
      code_rfid += UID[3];
      code_rfid += UID[4];
      digitalWrite(led2, HIGH);
      
      if (etat_module == 0){
       if (myTime - prev_time_rfid >= interval_rfid) {
      
        prev_time_rfid_1 = myTime;
        const char* val =code_rfid.c_str();
        snprintf (msg1, MSG_BUFFER_SIZE, "%s",val);
        client.publish("ID_USER", msg1);
        Serial.println(msg1);
        digitalWrite(led4, HIGH);
        last_code_rfid = code_rfid;
        }
    
      }

        
    monModuleRFID.halt();
      
  }
      
  delay(1); 
  code_rfid ="";

  }


  void last_rfid() {
    if (monModuleRFID.isCard()) {  
            if (monModuleRFID.readCardSerial()) {        
              for(int i=0;i<=4;i++)
              {
                UID[i]=monModuleRFID.serNum[i];  
              }
            
            }
            
      code_rfid = UID[0];
      code_rfid += UID[1];
      code_rfid += UID[2];
      code_rfid += UID[3];
      code_rfid += UID[4];
    if (myTime - prev_time_rfid_1 >= interval_rfid_1) {

        prev_time_rfid = myTime;
        if (last_code_rfid == code_rfid)
        {
        etat_module = 0;
        } 
        
      }
    
    }       
      monModuleRFID.halt();

      delay(1); 
      code_rfid ="";
  }


// void rotary 

  void IRAM_ATTR updat() {

  // on mesure A
    etatA = digitalRead(pinA);
    
      // controle du temps pour eviter des erreurs 
      if( millis() - tempsA > 50 ){
        // Si B different de l'ancien état de A alors
        if(digitalRead(pinB) != dernierEtatA){
          if(compteur > 0){
          compteur--;
          }
        }
        else{
          if (etat_access == 0){
          if(compteur < 4){
          compteur++;
            }
          }
          else {
            if(compteur < 1){
          compteur++;
            }
            
            }
        }
        // memorisation du temps pour A
        tempsA = millis();
      } 
      // memorisation de l'état de A
      dernierEtatA = etatA ;

  }

//void principale 
  void setup() {
    setup_LCD2004();
    starting();
    delay(3000);
    setup_OTA ();
    setup_mqtt();

    pinMode(pinA,INPUT);
    pinMode(pinB,INPUT);

    // état de A au setup
    dernierEtatA = digitalRead(pinA);
    // memorisation du temps pour eviter des erreurs de changements d'etat
    tempsA = millis();
    
    pinMode(pinButton,INPUT_PULLUP);  
    
    // Atach a CHANGE interrupt to PinB and exectute the update function when this change occurs.
    attachInterrupt(digitalPinToInterrupt(pinA), updat, CHANGE);
    
  }

  void loop() {
    
    myTime = millis();
    
    if (!client.connected()) {
      reconnect();
    }
    client.loop();
    
    home_display();
    
    
    
    if (etat_module == 0){
    ID_display ();
    rfid();
    }
    
    if (etat_module == 1){ 
      
      buttonvalue = digitalRead(pinButton);

      if (prevbuttonvalue != buttonvalue){
        if(buttonvalue == LOW){
          counter++;
          if(counter % 2 != 0){
            ID_machine = Machine[compteur][0]+":";
          }
          else{
            ID_machine+=compteur;
            const char* val1 =ID_machine.c_str();
            snprintf (msg1, MSG_BUFFER_SIZE, "%s",val1);
            client.publish("CMD_Machine", msg1);
            ID_machine = "";

          }
          
          compteur = 0;
        }
      }
      
      prevbuttonvalue = buttonvalue;

      if(counter % 2 != 0){
        etat_access = 1;
        
      }
      else{
        etat_access = 0;
      }  

      
      
      if (etat_access == 0){
        acces();
        
      }
      else{
        acces_1(); 
             
      }

      last_rfid();
      
    }



  }
